﻿using System;
using System.Linq;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.Extensions.Logging;
namespace ConsoleApplication
{
    public class Program
    {
          public static void Main(string[] args)
        {
            //create and seed database
            using (var context = new BookContext())
            {
               context.Database.EnsureDeleted();
               context.Database.EnsureCreated();
                var book = new Book("In the Company of Newfies");
                book.BookWasLoaned(14);
                context.Books.Add(book);
                context.SaveChanges();
            }
            using (var contextNew = new BookContext())
            {
                contextNew.GetService<ILoggerFactory>().AddProvider(new LoggerProvider());
                var BooksFromContext = contextNew.Books.Include(b=>b.BookLoans).ToList();
                foreach (var bookFromContext in BooksFromContext)
                {
                    Console.WriteLine(bookFromContext.Name);
                    foreach (var loan in bookFromContext.BookLoans)
                    {
                        Console.WriteLine($"   Loaned: {loan.Start.ToString("d")}  Due: {loan.DueDate.ToString("d")}");
                    }
                }
                //this is to show that QueryTrackingBehavior setting in BookContext is working
                Console.WriteLine($"Tracked Entities: {contextNew.ChangeTracker.Entries().Count()}");
            }
        }
    }
}
