
using Microsoft.EntityFrameworkCore;

public class BookContext : DbContext
{

    public DbSet<Book> Books { get; set; }
    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<BookLoan>().Property(bl => bl.DueDate);
        modelBuilder.Entity<BookLoan>().Property(bl => bl.Start);
        modelBuilder.Entity<BookLoan>().Property(bl => bl.DaysLoaned);
    }
    public BookContext(DbContextOptions<BookContext> options)
    : base(options) { }

    public BookContext() { 
          this.ChangeTracker.QueryTrackingBehavior = QueryTrackingBehavior.NoTracking;
    }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
    {
         optionsBuilder.UseSqlite("Data source=Books.db");
     
     }

}
 





